// ============================================================================
// $Id: imuddefs.hh,v 1.9 1997/10/22 14:39:24 chris Exp $
//
// This is part of Realm Of Magic
//
// Usage: header file for the intermud client
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Sushi)
// ============================================================================

#ifndef __INTERMUD__IMUDDEFS_HH__
#define __INTERMUD__IMUDDEFS_HH__

#include <string>

// C Includes:
#include <cerrno>

// Net Includes
#include <netinet/in.h>

#define LOWER(c) (((c)>='A' && (c) <='Z') ? ((c)+('a'-'A')) : (c))
#define UPPER(c) (((c)>='a' && (c)<='z') ? ((c)+('A'-'a')) : (c))

#define IS_SET(flag, bit) ((flag) & (bit))
#define SET_BIT(var, bit) ((var) |= (bit))

#define ST_INTERWIZ     (1 << 0)
#define ST_INTERTELL    (1 << 1)
#define ST_INTERPAGE    (1 << 2)
#define ST_INTERWHO     (1 << 3)

// Structures

struct lpc_info_record {
  int id_nr;
  unsigned short udp_port;
  string mud_name;
  string channel;
  string request;
  string sender;
  string recipent;
  string data;
  string reply_type;
};
  
struct dns_record {
  unsigned long      ip_address;
  unsigned short     port;
  string             mud_name;
  string             mud_port;
  string             mud_version;
  string             intermud_version;
  int                mud_type;
  unsigned long      kb_in;
  unsigned long      kb_out;
  unsigned long      msg_in;
  unsigned long      msg_out;
  int                muted;
  long               services;
  string             last_connected;
};

#endif
